import sys
import os
import math
import re
import random
import time
#Requirements : doalarm should print something that indicates timeout. For now lets say that command
#Variables are indexed from 1 to N not 0 to N-1
#Initialization : Ensure there exists a log/results & log/inputFiles folder in the parent directory
fileaddOfRandom = ''
fileaddOfRandPickTable = ''
randPickTable = {} #For every key k, the numbers m and n such that 2^n mod m gives the most efficient way of picking a random number from 0 to k-1 
randTotalLen = 0
randData = ''
randIndex = 0
TMPDIR = "tmp"
def ensureDirectory(path):
    d = os.path.dirname(path)
    if not os.path.exists(d):
        os.makedirs(d)
def usage():
    usageStr = "Usage : python MBoundGenerator.py <timeout> <filename>"
    print usageStr
    exit(1)
def init():
    global TMPDIR
    ensureDirectory("log/results/")
    ensureDirectory(TMPDIR+"/")
    ensureDirectory(TMPDIR+"/inputFiles/")
    ensureDirectory("log/logging/")
# returns a number between 0 and totalCount-1
def bin(x):
    if x<0:
        return '-'+bin(-x)
    out = []
    if (x == 0):
        out.append('0')
    while (x>0):
        out.append('01'[x&1])
        x >>= 1
        pass
    try:
        return ''.join(reversed(out))
    except NameError,ne2:
        out.reverse()   
    return ''.join(out)
def getBinary(binLen):
    byteLen = 1+binLen/8
    _random_source = open("/dev/urandom","rb")
    randBytes = _random_source.read(byteLen)
    _random_source.close()

    randInt = int(randBytes.encode("hex"),16)
    randBin = bin(randInt).zfill(binLen)
    return randBin[:binLen]
def findMin(numList):
    minNum = 100000000
    for ele in numList:
        if (int(ele) < minNum):
            minNum = int(ele)
    return minNum
def findHashBits(numVariables,numHash):
    randBitsTotal = getBinary(numVariables+2*numHash)
    randBits=''
    for i in range(numVariables+1):
        xorResult = 0
        for j in range(numHash):
            xorResult = xorResult^int(randBitsTotal[i+j])
        randBits += str(xorResult)
    return randBits
def isSolvable(fileName,initialFileName,logFileName,timeout):
    outputFileName = str(TMPDIR)+"/res_"+str(initialFileName)+".txt"
    maxSolutions = 2000000000000000000;
    startTime = time.time()
    cmd = "./doalarm -t real "+str(timeout)+" ./cryptominisat --nosolprint --gaussuntil=400 --verbosity=0 --maxsolutions="+str(maxSolutions)+" "+str(fileName)+" > "+str(outputFileName)
    os.system(cmd)
    endTime = time.time()
    f = open(outputFileName,'r')
    lines = f.readlines()
    f.close()
    #print lines
    if (len(lines) == 0):
        return 3,0
    #to encouter for some time offs
    if (endTime -startTime > timeout-20):
        return 2,0
    res = lines[len(lines)-1]
    solCount = len(lines)
    #When timeout occurs
    if (res.strip() == 'Alarm clock: 14'):
        return 2,0
    if (lines[0].strip() == 'c UNSATISFIABLE'):
        return 3,0
    if (res.strip() == 'c UNSATISFIABLE'):
        solCount = solCount -1
    #print res
    #print solCount
    if (solCount == maxSolutions):
        return 2,0
    else:
        #randNum = getRandomNum(solCount)
        return 0,solCount
def addRandomConstraints(initialFileName,finalFileName,numVariables,numClauses,numHash):
    hashClauses = ''
    for i in range(int(numHash)):
        varNum = 0
        randBits = findHashBits(numVariables,numHash)
        hashClauses = hashClauses+'x'
        needToNegate = False
        if (randBits[0] == '1'):
            needToNegate = True
        for j in range(1, numVariables+1):
            if (randBits[j] == '1'):
                varNum = varNum+1
                if (needToNegate):
                    hashClauses = hashClauses+'-'
                    needToNegate = False
                hashClauses = hashClauses+str(j)+' '
        hashClauses = hashClauses+' 0\n'
    f = open(initialFileName,'r')
    lines = f.readlines()
    f.close()
    f = open(finalFileName,'w')
    f.write('p cnf '+str(numVariables)+' '+str(numClauses+numHash)+'\n')
    for line in lines:
        f.write(str(line.strip())+'\n')
    if (numHash > 0):
        f.write(hashClauses)
    f.close()
def main():
    if ((len(sys.argv) < 2)):
        usage()
    timeout = int(sys.argv[1])
    initialFileName = sys.argv[2]
    numIterations = 4
    if (len(sys.argv) > 3):
        numIterations = int(sys.argv[3])
    alpha = 1
    if (len(sys.argv) > 4):
        alpha = int(sys.argv[4])
    f = open(initialFileName,'r')
    lines = f.readlines()
    numVariables = 0
    numClauses = 0
    for line in lines:
        if (str(line.strip()[0:5]) == 'p cnf'):
            fields = line.strip().split(' ')
            numVariables = int(fields[2])
            numClauses = int(fields[3])
            break
    initialFileNameSuffix = initialFileName.split('/')[-1][:-4]
    logFileName = "log/logging/log_"+str(initialFileNameSuffix)+'.txt'
    finalFileName = TMPDIR+"/inputFiles/input_"+str(initialFileNameSuffix)+".cnf"
    initialFileNameWithoutExt = initialFileName[:-4]
    init()
    g = open(logFileName,'w')
    logStr = 'sVal:time:retVal\n'
    #g.write(logStr)
    g.close()
    unsatMaxTry = 3
    totalSolList = []
    hashCountList = []
    shouldLog = False
    for i in range(numIterations):
        randSol = ''
        sVal = 1
        lowerS = 1
        upperS = 1
        unsatTry = 0
        while(True):
            startTime = time.time()
            addRandomConstraints(initialFileName,finalFileName,numVariables,numClauses,sVal)
            retVal,totalSolutions = isSolvable(finalFileName,initialFileName,logFileName,timeout)
            endTime = time.time()
            timeDiff = endTime-startTime
            if (shouldLog):
                g = open(logFileName,'a')
                logStr = str(sVal)+':'+str(timeDiff)+':'+str(retVal)+'\n'
                g.write(logStr)
                g.close()
            #timeout due to large number of solutions
            if (retVal == 2):
                if (upperS == sVal):
                    lowerS = sVal
                    sVal = 2*sVal
                    upperS = sVal
                else:
                    lowerS = sVal
                    sVal = (sVal+upperS)/2
                    
                continue
            #timeout due to no solutions/ unsat -we should first retry for the number of times
            if (retVal == 3):
                unsatTry += 1
                if (unsatTry < unsatMaxTry):
                    continue
                else:
                    unsatTry = 0
                    upperS = sVal
                    sVal =(lowerS +sVal)/2
                    
                continue
            if (retVal == 0):
                totalSolList.append(totalSolutions)
                hashCountList.append(sVal-alpha)
                break
    minHashCount = findMin(hashCountList)
    resultMapList = []
    print hashCountList
    print totalSolList
    for i in range(len(hashCountList)):
        resultMapList.append(pow(2,hashCountList[i]-minHashCount)*totalSolList[i])
    minValue = findMin(resultMapList)
    print minValue*pow(2,minHashCount)
main()
        
    
