#!/bin/bash

# runs minicount repeatedly on formula $1, outputting the decision depth
# (#sol estimate is 2^decisions)

TRIES=100

echo "Decisions"
for I in `seq $TRIES`
do
    RES=`./minicount $SEED $1 2>&1 |
	grep -E "COUNT|LAST_RAND_NUM"`
    
    # get the last random num for seed
    SEED="-seed=`echo $RES | cut -d' ' -f5`"

    # get the number of decisions
    echo $RES | cut -d' ' -f3
    
done 

